package dareka.common;

import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;

public class LRUMap<K, V> extends LinkedHashMap<K, V> {
	
	private static final long serialVersionUID = 1L;
	private int maxEntries;
	
	/**
	 * ŏeʂLRUMap쐬
	 */
	public LRUMap() {
		this(12);
	}
	
	/**
	 * w肳ꂽőGgLRUMap쐬B
	 * }bveʂ͍őGg܂悤ɒB
	 * 
	 * @param maxEntries őGg
	 */
	public LRUMap(int maxEntries) {
		super(maxEntries > 12 ? (int)(maxEntries * 1.4) : 16, 0.75f, true);
		setMaxEntries(maxEntries);
	}
	
	/**
	 * }bv̍őGg擾B
	 * 
	 * @return őGg
	 */
	public int getMaxEntries() {
		return maxEntries;
	}
	
	/**
	 * }bv̍őGgݒ肷B
	 * őGgkꍇ͌ÂGg폜B
	 * 
	 * @param maxEntries Vɐݒ肷őGg
	 */
	public void setMaxEntries(int maxEntries) {
		this.maxEntries = Math.max(maxEntries, 12);
		if (size() > maxEntries) {
			Iterator<K> i = keySet().iterator();
			while (size() > maxEntries && i.hasNext()) {
				i.next(); i.remove();
			}
		}
	}
	
	protected boolean removeEldestEntry(Map.Entry<K, V> eldest) {
		return size() > maxEntries;
	}

}
