package dareka.common.regex;

import java.util.Stack;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.Pair;
import dareka.common.Logger;

public class NestMatcher extends JavaMatcher {
	CharSequence content;
	Matcher t = null;
	Matcher c = null;
	Pattern conPattern = null;
	
	int last = 0, matchStart = 0;
	
	NestMatcher(NestPattern np, CharSequence input) {
		t = np.tagPattern.matcher(input);
		c = np.conPattern.matcher(input);
		conPattern = np.conPattern;
		content = input;
	}

	@Override
	public boolean find() {
		Stack<Pair<Integer, Integer>> tag = new Stack<Pair<Integer, Integer>>();
		while(t.find()) {
			if (t.group(1) != null) {
				// Jn^O
				tag.push(new Pair<Integer, Integer>(t.start(), t.end()));
			} else {
				// I^O
				if (!tag.empty()) {
					Pair<Integer, Integer> se = tag.pop();
					matchStart = se.first;
					c.region(se.second, t.start());
					if (c.find()) {
						t.region(t.end(), t.regionEnd());
						return true;
					}
				}
			}
		}
		
		return false;
	}

	@Override
	public CharSequence group() {
//Ԃ͈͂$NESTŎw肵^O܂Ŋ܂߂悤
//		return content.subSequence(c.regionStart(), c.regionEnd());
		return content.subSequence(matchStart, t.regionStart());
	}

	@Override
	public void appendReplacement(StringBuffer sb, String replacement) {
		sb.append(content.subSequence(last, matchStart));
// $0͓ʂȂ̂Őɒu
// Replace̓ꕶ2GXP[v(Ƃxu邽)
		replacement = replacement.replaceAll("(?<!\\\\)(?:(?:\\\\\\\\)*)\\$0(?!\\d)", Matcher.quoteReplacement(Matcher.quoteReplacement(content.subSequence(matchStart, t.regionStart()).toString())));

// ̂܂replaceFirstƁAy[WŜԂĂ
// }b`݂̂uĎ擾郁\bĥŁA
// }b`݂̂Stringɂx}b`
// }b`O̐擪/Ōɐǂ/ǂ݂ƓR}b`ȂȂ̂ŁA
// O".*"uȂǂđΏKvA
// Matches()ł͂Ȃfind()Ȃ̂ŁAȐK\ƌdɂȂ
// "^$" Ȃǂ̋EƂ
		String rep = c.group();
		Matcher m = conPattern.matcher(rep);
		if (!m.matches()) {
			Logger.info("$NEST matching Error.");
		}
		rep = m.replaceFirst(replacement);
		sb.append(rep);
		last = t.regionStart();
	}

	@Override
	public void appendTail(StringBuffer sb) {
		sb.append(content.subSequence(last, content.length()));
	}
}
