package dareka.processor.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.Method;
import java.util.HashMap;

import dareka.common.CloseUtil;
import dareka.common.Logger;

/**
 * \bhNX
 */
class MethodInfo {
	/** CX^X */
	public Object instance;
	/** \bh */
	public Method method;
	/**  */
	public Object[] args;
	/** xs邩ǂ */
	public boolean once;
	
	/**
	 * RXgN^
	 * 
	 * @param instance CX^X
	 * @param method \bh
	 * @param args 
	 * @param once xs邩ǂ
	 */
	public MethodInfo(Object instance, Method method, Object[] args, boolean once) {
		this.instance = instance;
		this.method   = method;
		this.args     = args;
		this.once     = once;
	}
	/**
	 * RXgN^
	 * 
	 * @param instance CX^X
	 * @param method \bh
	 * @param args 
	 */
	public MethodInfo(Object instance, Method method, Object[] args) {
		this(instance, method, args, true);
	}
}

/**
 * ȈLocalFlvev[gNX
 * <p>
 * config.propertiestemplateFileŎw肵t@Cev[gƂĎgp܂B
 * ftHg/local/list.htmlłB
 * ev[gꍇ́AW list.js gpLbVǗy[W\܂B
 * </p>
 *
 */
public class LocalFlvTemplate {
	/** ݒl */
	private File templateFile;
	/** R[h */
	private String fileEncoding = "UTF-8";
	/** L[[h˃IuWFNg ϊe[u */
	private HashMap<String, Object> objectTable = new HashMap<String, Object>();
	/** L[[h˃\bh ϊe[u */
	private HashMap<String, MethodInfo> methodTable = new HashMap<String, MethodInfo>();
	
	/**
	 * RXgN^
	 * 
	 * @param templateFile ev[gt@C
	 */
	public LocalFlvTemplate(File templateFile) {
		this.templateFile = templateFile;
	}
	
	/**
	 * ev[gt@Cǂݍ݁AL[[hǔʂԂ܂B
	 * 
	 * @return 
	 * @throws IOException ev[gt@C̓ǂݍ݂Ɏsꍇ
	 */
	public String execute() throws IOException {
		File f = templateFile;
		StringBuilder templateFile = new StringBuilder("");
		BufferedReader br = null;
		
		try {
			String str = null;
			String sep = System.getProperty("line.separator");
			
			// TODO t@CLbV
			br = new BufferedReader(new InputStreamReader(new FileInputStream(f), fileEncoding));
			while ((str = br.readLine()) != null) {
				templateFile.append(str).append(sep);
			}
		} catch (IOException e) {
			throw e;
		} finally {
			CloseUtil.close(br);
		}
		
		return replaceAll(templateFile.toString());
	}
	
	/**
	 * L[[h蓖ĂꂽIuWFNg̕܂̓\bh̎sʂɒu܂B
	 * 
	 * @param contents ev[gRec
	 * @return 
	 */
	protected String replaceAll(String contents) {
		StringBuilder buf = new StringBuilder(contents.length());
		
		int pos = 0;
		while (pos < contents.length()) {
			char c = contents.charAt(pos);
			switch(c) {
			case '$':
				String key = getKeyword(contents, pos);
				if (key != null && containsKey(key)) {
					Logger.debug("match keyword: " + key);
					String value = getValue(key);
					buf.append(value);
					pos += (3 + key.length());
					break;
				}
			default:
				buf.append(c);
				pos += 1;
			}
		}
		
		return buf.toString();
	}
	
	/**
	 * L[[h𒊏o܂B
	 * 
	 * @param contents Rec
	 * @param pos ݈ʒu
	 * @return L[[hBȂꍇnullB
	 */
	protected String getKeyword(String contents, int pos) {
		if (contents.charAt(pos+1) != '{') return null;
		
		int start = pos + 2;
		int end   = contents.indexOf('}', start);
		if (end < 0) return null;
		
		String key = contents.substring(start, end);
		
		return key;
	}
	
	/**
	 * 蓖ĂꂽIuWFNg猋ʂ擾܂B
	 * 
	 * @param key L[[h 
	 * @return 
	 */
	protected String getValue(String key) {
		if (objectTable.containsKey(key)) {
			return objectTable.get(key).toString();
		}
		Object value = null;
		MethodInfo info = methodTable.get(key);
		try {
			// \bhs
			value = info.method.invoke(info.instance, info.args);
		} catch (Exception e) {
			Logger.error(e);
		}
		String result = (value == null) ? "" : value.toString();
		if (info.once) {
			objectTable.put(key, result);
			methodTable.remove(key);
		}
		
		return result;
	}
	
	/**
	 * L[[hɃIuWFNg蓖Ă܂B
	 * 
	 * @param key L[[h
	 * @param value IuWFNg
	 * @return Ɋ蓖ĂĂꍇfalse
	 */
	public boolean assign(String key, Object value) {
		if (containsKey(key)) return false;
		objectTable.put(key, value);
		return true;
	}
	
	/**
	 * L[[hɃ\bh蓖Ă܂B
	 * 
	 * @param key L[[h
	 * @param instance 蓖Ă郁\bhCX^X
	 * @param method \bh
	 * @param args 
	 * @param once 1񂾂s
	 * @return Ɋ蓖ĂĂꍇfalse
	 */
	public boolean assign(String key, Object instance, Method method, Object[] args, boolean once) {
		if (containsKey(key)) return false;
		methodTable.put(key, new MethodInfo(instance, method, args, once));
		return true;
	}
	
	/**
	 * L[[hstatic\bh蓖Ă܂B
	 * 
	 * @param key L[[h
	 * @param method static\bh
	 * @param args 
	 * @return Ɋ蓖ĂĂꍇfalse
	 */
	public boolean assign(String key, Method method, Object[] args) {
		return assign(key, null, method, args, true);
	}
	
	/**
	 * L[[hstatic\bh蓖Ă܂B
	 * 
	 * @param key L[[h
	 * @param method static\bh
	 * @return Ɋ蓖ĂĂꍇfalse
	 */
	public boolean assign(String key, Method method) {
		return assign(key, null, method, null, true);
	}
	
	/**
	 * L[[hɃ\bh蓖Ă܂B
	 * 
	 * @param key L[[h
	 * @param instance 蓖Ă郁\bhCX^X
	 * @param method \bh
	 * @return Ɋ蓖ĂĂꍇfalse
	 */
	public boolean assign(String key, Object instance, Method method) {
		return assign(key, instance, method, null, true);
	}

	/**
	 * 蓖ĂSĉ܂B
	 *
	 */
	public void clear() {
		objectTable.clear();
		methodTable.clear();
	}

	/**
	 * L[[hɊ蓖ĂĂ邩ׂ܂B
	 * 
	 * @param key L[[h
	 * @return 蓖ĂĂtrue
	 */
	public boolean containsKey(Object key) {
		if (objectTable.containsKey(key) || methodTable.containsKey(key)) {
			return true;
		}
		return false;
	}

	/**
	 * ev[gt@C̕R[hw肵܂B<br>
	 * ftHgUTF-8łB
	 * 
	 * @param fileEncoding R[h
	 */
	public void setFileEncoding(String fileEncoding) {
		this.fileEncoding = fileEncoding;
	}
}